/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreTranslationKey.TCoreTranslationKeyPath;
import de.ship.db.tables.TInputTypeparam.TInputTypeparamPath;
import de.ship.db.tables.records.TInputTypeparamlistRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TInputTypeparamlist extends TableImpl<TInputTypeparamlistRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_input_typeparamlist</code>
     */
    public static final TInputTypeparamlist T_INPUT_TYPEPARAMLIST = new TInputTypeparamlist();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TInputTypeparamlistRecord> getRecordType() {
        return TInputTypeparamlistRecord.class;
    }

    /**
     * The column
     * <code>common_dd.t_input_typeparamlist.pk_input_typeparamlist</code>.
     */
    public final TableField<TInputTypeparamlistRecord, Integer> PK_INPUT_TYPEPARAMLIST = createField(DSL.name("pk_input_typeparamlist"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column
     * <code>common_dd.t_input_typeparamlist.fk_inputtypeparam</code>.
     */
    public final TableField<TInputTypeparamlistRecord, Integer> FK_INPUTTYPEPARAM = createField(DSL.name("fk_inputtypeparam"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_input_typeparamlist.paramvalue</code>.
     */
    public final TableField<TInputTypeparamlistRecord, Integer> PARAMVALUE = createField(DSL.name("paramvalue"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_input_typeparamlist.paramvalue_lang</code>.
     */
    public final TableField<TInputTypeparamlistRecord, String> PARAMVALUE_LANG = createField(DSL.name("paramvalue_lang"), SQLDataType.CLOB.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_input_typeparamlist.lastchange</code>.
     */
    public final TableField<TInputTypeparamlistRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    private TInputTypeparamlist(Name alias, Table<TInputTypeparamlistRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TInputTypeparamlist(Name alias, Table<TInputTypeparamlistRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_input_typeparamlist</code> table
     * reference
     */
    public TInputTypeparamlist(String alias) {
        this(DSL.name(alias), T_INPUT_TYPEPARAMLIST);
    }

    /**
     * Create an aliased <code>common_dd.t_input_typeparamlist</code> table
     * reference
     */
    public TInputTypeparamlist(Name alias) {
        this(alias, T_INPUT_TYPEPARAMLIST);
    }

    /**
     * Create a <code>common_dd.t_input_typeparamlist</code> table reference
     */
    public TInputTypeparamlist() {
        this(DSL.name("t_input_typeparamlist"), null);
    }

    public <O extends Record> TInputTypeparamlist(Table<O> path, ForeignKey<O, TInputTypeparamlistRecord> childPath, InverseForeignKey<O, TInputTypeparamlistRecord> parentPath) {
        super(path, childPath, parentPath, T_INPUT_TYPEPARAMLIST);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TInputTypeparamlistPath extends TInputTypeparamlist implements Path<TInputTypeparamlistRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TInputTypeparamlistPath(Table<O> path, ForeignKey<O, TInputTypeparamlistRecord> childPath, InverseForeignKey<O, TInputTypeparamlistRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TInputTypeparamlistPath(Name alias, Table<TInputTypeparamlistRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TInputTypeparamlistPath as(String alias) {
            return new TInputTypeparamlistPath(DSL.name(alias), this);
        }

        @Override
        public TInputTypeparamlistPath as(Name alias) {
            return new TInputTypeparamlistPath(alias, this);
        }

        @Override
        public TInputTypeparamlistPath as(Table<?> alias) {
            return new TInputTypeparamlistPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TInputTypeparamlistRecord, Integer> getIdentity() {
        return (Identity<TInputTypeparamlistRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TInputTypeparamlistRecord> getPrimaryKey() {
        return Keys.PK_INPUT_TYPEPARAMLIST;
    }

    @Override
    public List<UniqueKey<TInputTypeparamlistRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_INPUT_TYPEPARAMLIST);
    }

    @Override
    public List<ForeignKey<TInputTypeparamlistRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_INPUT_TYPEPARAMLIST__FK_INPUTTYPEPARAMLIST_REF, Keys.T_INPUT_TYPEPARAMLIST__FK_INPUTTYPEPARAMLIST_LANG);
    }

    private transient TInputTypeparamPath _tInputTypeparam;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_input_typeparam</code> table.
     */
    public TInputTypeparamPath tInputTypeparam() {
        if (_tInputTypeparam == null)
            _tInputTypeparam = new TInputTypeparamPath(this, Keys.T_INPUT_TYPEPARAMLIST__FK_INPUTTYPEPARAMLIST_REF, null);

        return _tInputTypeparam;
    }

    private transient TCoreTranslationKeyPath _tCoreTranslationKey;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_translation_key</code> table.
     */
    public TCoreTranslationKeyPath tCoreTranslationKey() {
        if (_tCoreTranslationKey == null)
            _tCoreTranslationKey = new TCoreTranslationKeyPath(this, Keys.T_INPUT_TYPEPARAMLIST__FK_INPUTTYPEPARAMLIST_LANG, null);

        return _tCoreTranslationKey;
    }

    @Override
    public TInputTypeparamlist as(String alias) {
        return new TInputTypeparamlist(DSL.name(alias), this);
    }

    @Override
    public TInputTypeparamlist as(Name alias) {
        return new TInputTypeparamlist(alias, this);
    }

    @Override
    public TInputTypeparamlist as(Table<?> alias) {
        return new TInputTypeparamlist(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputTypeparamlist rename(String name) {
        return new TInputTypeparamlist(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputTypeparamlist rename(Name name) {
        return new TInputTypeparamlist(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputTypeparamlist rename(Table<?> name) {
        return new TInputTypeparamlist(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputTypeparamlist where(Condition condition) {
        return new TInputTypeparamlist(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputTypeparamlist where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputTypeparamlist where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputTypeparamlist where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputTypeparamlist where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputTypeparamlist where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputTypeparamlist where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputTypeparamlist where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputTypeparamlist whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputTypeparamlist whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
